package com.ynet.life.memcached;

import com.danga.MemCached.MemCachedClient;
import com.danga.MemCached.SockIOPool;
import com.ynet.life.base.LifeStandard;
import com.ynet.life.base.TEntity;
import com.ynet.life.base.Trace;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.util.Properties;

public class LifeMemcachedSessionService {

   private static LifeMemcachedSessionService instance = null;
   private SockIOPool pool = null;
   private String serverlists = "serverlist";
   private String poolName = "poolname";
   private static MemCachedClient mc = null;
   private String logName = "LifeMemcachedSessionService";


   public static synchronized LifeMemcachedSessionService getInstance() {
      if(instance == null) {
         instance = new LifeMemcachedSessionService();
      }

      return instance;
   }

   private LifeMemcachedSessionService() {
      String e = TEntity.memcachedPath;
      String servers = LifeStandard.getRootPath();
      FileInputStream in = null;

      try {
         e = servers + "WEB-INF" + e;
         in = new FileInputStream(e);
      } catch (FileNotFoundException var5) {
         Trace.logError(this.logName, var5.getMessage(), var5);
      }

      Properties e1 = new Properties();

      try {
         e1.load(in);
         servers = e1.getProperty(this.serverlists);
         e = e1.getProperty(this.poolName);
         String[] servers1 = servers.split(",");
         Integer[] var10000 = new Integer[]{Integer.valueOf(3), Integer.valueOf(3), Integer.valueOf(2)};
         this.pool = SockIOPool.getInstance(e);
         this.pool = SockIOPool.getInstance();
         this.pool.setServers(servers1);
         this.pool.setFailover(true);
         this.pool.setInitConn(10);
         this.pool.setMinConn(5);
         this.pool.setMaxConn(250);
         this.pool.setMaxIdle(21600000L);
         this.pool.setMaintSleep(30L);
         this.pool.setNagle(false);
         this.pool.setSocketTO(3000);
         this.pool.setSocketConnectTO(0);
         this.pool.setAliveCheck(true);
         this.pool.initialize();
         Trace.log(this.logName, "memcached服务器初始化成功!");
      } catch (Exception var4) {
         Trace.log(this.logName, "memcached服务器初始化失败!");
         var4.printStackTrace();
      }
   }

   public synchronized MemCachedClient getMemCachedClient() {
      if(mc == null) {
         mc = new MemCachedClient();
      }

      return mc;
   }

   protected void finalize() {
      if(this.pool != null) {
         this.pool.shutDown();
      }

   }

   public static void main(String[] args) {
      getInstance();
   }
}
